diff --git a/gnu/packages/tree-sitter.scm b/gnu/packages/tree-sitter.scm
index 3357fce4a5..13f7a63acc 100644
--- a/gnu/packages/tree-sitter.scm
+++ b/gnu/packages/tree-sitter.scm
@@ -19,6 +19,7 @@
 (define-module (gnu packages tree-sitter)
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix build-system cargo)
+  #:use-module (guix build-system emacs)
   #:use-module (guix build-system gnu)
   #:use-module (guix build-system node)
   #:use-module (guix download)
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages crates-graphics)
   #:use-module (gnu packages crates-io)
+  #:use-module (gnu packages llvm)
   #:use-module (gnu packages node-xyz))

 (define-public tree-sitter
@@ -603,3 +605,80 @@ library.")
       "This package provides Typescript and TSX grammars for the Tree-sitter
 library.")
     (license license:expat)))
+
+;; Local package definition solely for building the native emacs module
+;; written in Rust.
+(define tree-sitter-emacs-module
+  (package
+    (name "tree-sitter-emacs-module")
+    (version "0.15.1")
+    (source (origin
+              (method git-fetch)
+              (uri (git-reference
+                    (url "https://github.com/emacs-tree-sitter/elisp-tree-sitter")
+                    (commit version)))
+              (file-name (git-file-name name version))
+              (sha256
+               (base32
+                "15y0wjnck8rbfhl0xrl71ci7clbcp11lhqil5l8ykprsdjv0c2as"))))
+    (build-system cargo-build-system)
+    (inputs
+     `(("clang" ,clang)))
+    (arguments
+     `(#:cargo-inputs
+       (("rust-anyhow" ,rust-anyhow-1)
+        ("rust-emacs" ,rust-emacs-0.17)
+        ("rust-libloading" ,rust-libloading-0.7)
+        ("rust-once-cell" ,rust-once-cell-1)
+        ("rust-tree-sitter" ,rust-tree-sitter-0.19))
+       #:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'delete-cargo.lock
+           (lambda _ (delete-file "Cargo.lock")))
+         (add-after 'delete-cargo.lock 'do-not-fetch-from-github
+           (lambda _
+             (substitute* "Cargo.toml"
+               (("\\[patch.*") "")
+               (("git = .*") ""))))
+         (add-after 'do-not-fetch-from-github 'chdir
+           (lambda _ (chdir "core")))
+         (replace 'install
+           (lambda* (#:key outputs #:allow-other-keys)
+             (let ((lib (string-append (assoc-ref outputs "out") "/lib")))
+               (install-file "../target/release/libtsc_dyn.so" lib)))))))
+    (home-page #f)
+    (synopsis #f)
+    (description #f)
+    (license license:expat)))
+
+(define-public emacs-tree-sitter-core
+  (package
+    (name "emacs-tree-sitter-core")
+    (version (package-version tree-sitter-emacs-module))
+    (source (package-source tree-sitter-emacs-module))
+    (build-system emacs-build-system)
+    (native-inputs
+     `(("tree-sitter-emacs-module" ,tree-sitter-emacs-module)))
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'chdir
+           (lambda _ (chdir "core")))
+         (add-after 'install 'install-module
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let ((elpa (elpa-directory (assoc-ref outputs "out")))
+                   (module (string-append (assoc-ref inputs "tree-sitter-emacs-module")
+                                          "/lib/libtsc_dyn.so")))
+               ;; Writing "LOCAL" in this file prevents the package from
+               ;; trying to download the module from the internet.
+               (call-with-output-file (string-append elpa "/DYN-VERSION")
+                 (lambda (port) (display "LOCAL" port)))
+               (substitute* "tsc-dyn-get.el"
+                 (("defcustom tsc-dyn-dir tsc--dir")
+                  (string-append "defcustom tsc-dyn-dir \"" elpa "\"")))
+               (copy-file module (string-append elpa "/tsc-dyn.so"))))))))
+    (home-page "https://github.com/emacs-tree-sitter/elisp-tree-sitter")
+    (synopsis "Tree-sitter bindings for Emacs Lisp, core library")
+    (description "This package provides core APIs of the Emacs binding for
+Tree-sitter, an incremental parsing system.")
+    (license license:expat)))